std::unordered_set< _Value, _Hash, _Pred, _Alloc >(3)

NAME
std::unordered_set< _Value, _Hash, _Pred, _Alloc > -

SYNOPSIS

  Public Types

typedef _Hashtable::key_type key_type
typedef _Hashtable::value_type value_type
typedef _Hashtable::hasher hasher
typedef _Hashtable::key_equal key_equal
typedef _Hashtable::allocator_type allocator_type

typedef _Hashtable::pointer pointer
typedef _Hashtable::const_pointer const_pointer
typedef _Hashtable::reference reference
typedef _Hashtable::const_reference const_reference
typedef _Hashtable::iterator iterator
typedef _Hashtable::const_iterator const_iterator
typedef _Hashtable::local_iterator local_iterator
typedef _Hashtable::const_local_iterator const_local_iterator
typedef _Hashtable::size_type size_type
typedef _Hashtable::difference_type difference_type

  Public Member Functions
unordered_set ()=default
unordered_set (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
template<typename _InputIterator > unordered_set (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
unordered_set (const unordered_set &)=default
unordered_set (unordered_set &&)=default
unordered_set (const allocator_type &__a)
unordered_set (const unordered_set &__uset, const allocator_type &__a)
unordered_set (unordered_set &&__uset, const allocator_type &__a)
unordered_set (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
size_type bucket (const key_type &__key) const
size_type bucket_count () const noexcept
size_type bucket_size (size_type __n) const
const_iterator cbegin () const noexcept
const_iterator cend () const noexcept
void clear () noexcept
size_type count (const key_type &__x) const
template<typename... _Args> std::pair< iterator, bool > emplace (_Args &&...__args)
template<typename... _Args> iterator emplace_hint (const_iterator __pos, _Args &&...__args)
bool empty () const noexcept
size_type erase (const key_type &__x)
iterator erase (const_iterator __first, const_iterator __last)
allocator_type get_allocator () const noexcept
hasher hash_function () const
template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
void insert (initializer_list< value_type > __l)
key_equal key_eq () const
float load_factor () const noexcept
size_type max_bucket_count () const noexcept
float max_load_factor () const noexcept
void max_load_factor (float __z)
size_type max_size () const noexcept
unordered_set & operator= (const unordered_set &)=default
unordered_set & operator= (unordered_set &&)=default
unordered_set & operator= (initializer_list< value_type > __l)
void rehash (size_type __n)
void reserve (size_type __n)
size_type size () const noexcept
void swap (unordered_set &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))

iterator begin () noexcept
const_iterator begin () const noexcept

iterator end () noexcept
const_iterator end () const noexcept

std::pair< iterator, bool > insert (const value_type &__x)
std::pair< iterator, bool > insert (value_type &&__x)

iterator insert (const_iterator __hint, const value_type &__x)
iterator insert (const_iterator __hint, value_type &&__x)

iterator erase (const_iterator __position)
iterator erase (iterator __position)

iterator find (const key_type &__x)
const_iterator find (const key_type &__x) const

std::pair< iterator, iterator > equal_range (const key_type &__x)
std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const

local_iterator begin (size_type __n)
const_local_iterator begin (size_type __n) const
const_local_iterator cbegin (size_type __n) const

local_iterator end (size_type __n)
const_local_iterator end (size_type __n) const
const_local_iterator cend (size_type __n) const

  Friends
template<typename _Value1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 > bool operator== (const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &, const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &)

Detailed Description

  template<class _Value, class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>>class std::unordered_set< _Value, _Hash, _Pred, _Alloc >
A standard container composed of unique keys (containing at most one of each key value) in which the elements' keys are the elements themselves.

Template Parameters:
    _Value Type of key objects.
    _Hash Hashing function object type, defaults to hash<_Value>.
    _Pred Predicate function object type, defaults to equal_to<_Value>.
    _Alloc Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

Base is _Hashtable, dispatched at compile time via template alias __uset_hashtable.

Definition at line 93 of file unordered_set.h.

Member Typedef Documentation

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::allocator_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::allocator_type

Public typedefs.

Definition at line 106 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 116 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_local_iterator

Iterator-related typedefs.

Definition at line 118 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::const_pointer std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 112 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::const_reference std::unordered_set< _Value, _Hash, _Pred, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 114 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::difference_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 120 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::hasher std::unordered_set< _Value, _Hash, _Pred, _Alloc >::hasher

Public typedefs.

Definition at line 104 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 115 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::key_equal std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_equal

Public typedefs.

Definition at line 105 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::key_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 102 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::local_iterator

Iterator-related typedefs.

Definition at line 117 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::pointer std::unordered_set< _Value, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 111 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::reference std::unordered_set< _Value, _Hash, _Pred, _Alloc >::reference

Iterator-related typedefs.

Definition at line 113 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 119 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> typedef _Hashtable::value_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::value_type

Public typedefs.

Definition at line 103 of file unordered_set.h.

Constructor & Destructor Documentation

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set () [default]

Default constructor.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (size_type __n, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline], [explicit]

Default constructor creates no elements.

Parameters:
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Definition at line 136 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> template<typename _InputIterator > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (_InputIterator __first, _InputIterator __last, size_type __n = 0, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline]

Builds an unordered_set from a range.

Parameters:
    __first An input iterator.
    __last An input iterator.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_set consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 157 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (const unordered_set< _Value, _Hash, _Pred, _Alloc > &) [default]

Copy constructor.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (unordered_set< _Value, _Hash, _Pred, _Alloc > &&) [default]

Move constructor.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (const allocator_type & __a) [inline], [explicit]

Creates an unordered_set with no elements.

Parameters:
    __a An allocator object.

Definition at line 176 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (initializer_list< value_type > __l, size_type __n = 0, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline]

Builds an unordered_set from an initializer_list.

Parameters:
    __l An initializer_list.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_set consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 211 of file unordered_set.h.

Member Function Documentation

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin () [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 276 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 280 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin (size_type __n) [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 627 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin (size_type __n) const [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 631 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::bucket_count () const [inline], [noexcept]

Returns the number of buckets of the unordered_set.

Definition at line 593 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 303 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cbegin (size_type __n) const [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 635 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 311 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cend (size_type __n) const [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 655 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::clear () [inline], [noexcept]
Erases all elements in an unordered_set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 504 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::count (const key_type & __x) const [inline]

Finds the number of elements.

Parameters:
    __x Element to located.

Returns:
    Number of elements with specified key.

This function only makes sense for unordered_multisets; for unordered_set the result will either be 0 (not present) or 1 (present).

Definition at line 568 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> template<typename... _Args> std::pair<iterator, bool> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace (_Args &&... __args) [inline]

Attempts to build and insert an element into the unordered_set.

Parameters:
    __args Arguments used to generate an element.

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to build and insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 333 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> template<typename... _Args> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace_hint (const_iterator __pos, _Args &&... __args) [inline]

Attempts to insert an element into the unordered_set.

Parameters:
    __pos An iterator that serves as a hint as to where the element should be inserted.
    __args Arguments used to generate the element to be inserted.

Returns:
    An iterator that points to the element with key equivalent to the one generated from __args (may or may not be the element itself).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument emplace() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant time.

Definition at line 359 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> bool std::unordered_set< _Value, _Hash, _Pred, _Alloc >::empty () const [inline], [noexcept]

Returns true if the unordered_set is empty.

Definition at line 255 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end () [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 290 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 294 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end (size_type __n) [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 647 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end (size_type __n) const [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters:
    __n The bucket index.

Returns:
    A read-only local iterator.

Definition at line 651 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::pair<iterator, iterator> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters:
    __x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 581 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::pair<const_iterator, const_iterator> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range (const key_type & __x) const [inline]

Finds a subsequence matching given key.

Parameters:
    __x Key to be located.

Returns:
    Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 585 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const_iterator __position) [inline]

Erases an element from an unordered_set.

Parameters:
    __position An iterator pointing to the element to be erased.

Returns:
    An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 454 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (iterator __position) [inline]

Erases an element from an unordered_set.

Parameters:
    __position An iterator pointing to the element to be erased.

Returns:
    An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 459 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters:
    __x Key of element to be erased.

Returns:
    The number of elements erased.

This function erases all the elements located by the given key from an unordered_set. For an unordered_set the result of this function can only be 0 (not present) or 1 (present). Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 476 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const_iterator __first, const_iterator __last) [inline]

Erases a [__first,__last) range of elements from an unordered_set.

Parameters:
    __first Iterator pointing to the start of the range to be erased.
    __last Iterator pointing to the end of the range to be erased.

Returns:
    The iterator __last.

This function erases a sequence of elements from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 494 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find (const key_type & __x) [inline]

Tries to locate an element in an unordered_set.

Parameters:
    __x Element to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 550 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find (const key_type & __x) const [inline]

Tries to locate an element in an unordered_set.

Parameters:
    __x Element to be located.

Returns:
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 554 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> allocator_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::get_allocator () const [inline], [noexcept]

Returns the allocator object with which the unordered_set was constructed.

Definition at line 248 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> hasher std::unordered_set< _Value, _Hash, _Pred, _Alloc >::hash_function () const [inline]

Returns the hash functor object with which the unordered_set was constructed.

Definition at line 526 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::pair<iterator, bool> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (const value_type & __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters:
    __x Element to be inserted.

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 377 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> std::pair<iterator, bool> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (value_type && __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters:
    __x Element to be inserted.

Returns:
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 381 of file unordered_set.h.

References std::move().

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (const_iterator __hint, const value_type & __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters:
    __hint An iterator that serves as a hint as to where the element should be inserted.
    __x Element to be inserted.

Returns:
    An iterator that points to the element with key of __x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 406 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (const_iterator __hint, value_type && __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters:
    __hint An iterator that serves as a hint as to where the element should be inserted.
    __x Element to be inserted.

Returns:
    An iterator that points to the element with key of __x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 410 of file unordered_set.h.

References std::move().

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> template<typename _InputIterator > void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attempts to insert a range of elements.

Parameters:
    __first Iterator pointing to the start of the range to be inserted.
    __last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 425 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (initializer_list< value_type > __l) [inline]

Attempts to insert a list of elements into the unordered_set.

Parameters:
    __l A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 436 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> key_equal std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_eq () const [inline]

Returns the key comparison object with which the unordered_set was constructed.

Definition at line 532 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::load_factor () const [inline], [noexcept]

Returns the average number of elements per bucket.

Definition at line 663 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_bucket_count () const [inline], [noexcept]

Returns the maximum number of buckets of the unordered_set.

Definition at line 598 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor () const [inline], [noexcept]

Returns a positive number that the unordered_set tries to keep the load factor less than or equal to.

Definition at line 669 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor (float __z) [inline]

Change the unordered_set maximum load factor.

Parameters:
    __z The new maximum load factor.

Definition at line 677 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_size () const [inline], [noexcept]

Returns the maximum size of the unordered_set.

Definition at line 265 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (const unordered_set< _Value, _Hash, _Pred, _Alloc > &) [default]

Copy assignment operator.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (unordered_set< _Value, _Hash, _Pred, _Alloc > &&) [default]

Move assignment operator.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (initializer_list< value_type > __l) [inline]

Unordered_set list assignment operator.

Parameters:
    __l An initializer_list.

This function fills an unordered_set with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_set and that the resulting unordered_set's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 239 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::rehash (size_type __n) [inline]

May rehash the unordered_set.

Parameters:
    __n The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_set maximum load factor.

Definition at line 688 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::reserve (size_type __n) [inline]

Prepare the unordered_set for a specified number of elements.

Parameters:
    __n Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 699 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::size () const [inline], [noexcept]

Returns the size of the unordered_set.

Definition at line 260 of file unordered_set.h.

  template<class _Value , class _Hash = hash<_Value>, class _Pred = std::equal_to<_Value>, class _Alloc = std::allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::swap (unordered_set< _Value, _Hash, _Pred, _Alloc > & __x) [inline], [noexcept]

Swaps data with another unordered_set.

Parameters:
    __x An unordered_set of the same element and allocator types.

This exchanges the elements between two sets in constant time. Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 517 of file unordered_set.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.